/////////////////////////////////////////////////////////////////////////////////////
//	1.  PROJECT     	: Automatic Voltage Regulator
//	2.  APPLICATION 	: 
//	3.  FUNCTION		: 
// 	4.  DEVICE      	: ATMega2560
// 	5.  DESIGN TOOL 	: AVR Studio 4.14 & WinAVR
// 	6.  FILENAME    	: main.h
// 	7.  VERSION     	: Ver 0.50		2008.10.01 start
//
//	COPYRIGHT (C) 2008  HINATEK-SYSTEM
/////////////////////////////////////////////////////////////////////////////////////

#ifndef	__UARTCOM_H
#define	__UARTCOM_H

#include "main.h"

#define	CRC_INIT_VALUE			0x0000
#define	RX_QUEUE_SIZE			128
#define	TX_QUEUE_SIZE			4096

#define	UART_1			0
#define	UART_2			1
//#define	UART_3			2
//#define	UART_4			3
//#define	UART_5			4
//#define	UART_6			5


typedef struct {
	BYTE		baRxQueue[RX_QUEUE_SIZE];
//	BYTE		baTxQueue[TX_QUEUE_SIZE];
	WORD		nRxTail;
	WORD        nRxHead;
	WORD		nTxTail;
	WORD        nTxHead;
} COMM_QUEUE;
extern COMM_QUEUE comm_queue[2];

//typedef struct _COMM_QUEUE	commQueue;
//extern	commQueue comm_queue;

//unsigned int ComputeBufferCRC(unsigned char *bpRecvData, unsigned int nBufferSize );

void Uart1_EnQueue(void);
void Uart2_EnQueue(void);
void Uart1_Send(BYTE *data, int _size);
void Uart2_Send(BYTE *data, int _size);
BYTE GetRx1Char(BYTE *pCh);
BYTE GetRx2Char(BYTE *pCh);
void UARTprintf(const char *pcString, ...);
	

void com_send_lora(BYTE *_pData, int _size);
void onoff_send(char _sel);
void data_analysys(char *p_Data, int size);

#endif
