#ifndef __FLASH_H__
#define __FLASH_H__

#include "main.h"
#include "tmac_typedefs.h"

typedef struct {
	char			log[1];
    char 	lora_freq;   
	unsigned char 	lora_grup;
	unsigned int 	sensor_id;
	
	uint16  sens_upunit;
	
	// 
	uint16  det_onth;           // detection info
    uint16  det_offth;
    uint16  det_onwait;
    uint16  det_offwait;
    uint16  det_blup;
    uint16  det_longon;    //jhsong x  
	
    uint8   ctrl_uvds;  
	
	uint16  det_longonwait;    
    uint8   det_longonStableVal;
    uint16  det_longonStableWait; 	
	uint16  det_status;       
	
	uint16         sens3_bl[4];
    uint8         bl_serch;
	int         blz_stopcock[4];
	int         blz_stopcock_tmp[4];
	uint16 		car_in_blz_stopcock[4];
} _sConfig;
extern _sConfig		config;

void	fn_eeprom_init();
void fn_config_write();

#endif