#ifndef __HW_CONFIG_H
#define __HW_CONFIG_H

//GPIO REDEFINE jhsong

#define PC4_PIN_I2C_POWER             GPIO_PIN_4

//I2C
#define PC5_PIN_I2C_SCL             GPIO_PIN_5
#define PC6_PIN_I2C_SDA             GPIO_PIN_6

//ADC
#define PA6_PIN_ADC_MAG             GPIO_PIN_6
#define PA7_PIN_ADC_BAT             GPIO_PIN_7

//232 ø 
#define PA1_PIN_UART_RXD            GPIO_PIN_1
#define PA0_PIN_UART_TXD            GPIO_PIN_0
#define PA3_PIN_UART_RXD2            GPIO_PIN_3 
#define PA2_PIN_UART_TXD2            GPIO_PIN_2 

// Mapped to "SELECT" button on board
#define EXAMPLE_GPIO_PIN                GPIO_PIN_3
#define EXAMPLE_INT_GPIO                INT_GPIOA

#define RF_PA_EN_PC3		GPIO_PIN_3	 //PC
#define RF_LNA_EN_PC2		GPIO_PIN_2	 //PC
#define RF_HGM_PD2		GPIO_PIN_2	 //PD

#define RUN_LED_PC0		GPIO_PIN_0	

void RCC_Configuration(void);
void interrupt_init(void);
void gpio_init(void);
void USART1_Init(uint32_t brate);
void USART2_Init(uint32_t brate);
void TIMER0_Init(void);
void I2C_init(void);
void ADC_init(void);
void Timer0BIntHandler(void);


#endif  /*__HW_CONFIG_H */